Commits

Anonymous committed f01cb59

Build mariadb for veclinux-7.1

Signed-off-by: Lee Pak Hong <benreilly@vl7light.linux.net>

Comments (0)

Files changed (3)

var/vabs/mariadb/src/doinst.sh

+config() {
+  NEW="$1"
+  OLD="$(dirname $NEW)/$(basename $NEW .new)"
+  # If there's no config file by that name, mv it over:
+  if [ ! -r $OLD ]; then
+    mv $NEW $OLD
+  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+    # toss the redundant copy
+    rm $NEW
+  fi
+  # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+# Keep same perms on rc.mysqld.new:
+if [ -e etc/rc.d/rc.mysqld ]; then
+  cp -a etc/rc.d/rc.mysqld etc/rc.d/rc.mysqld.new.incoming
+  cat etc/rc.d/rc.mysqld.new > etc/rc.d/rc.mysqld.new.incoming
+  mv etc/rc.d/rc.mysqld.new.incoming etc/rc.d/rc.mysqld.new
+fi
+
+config etc/rc.d/rc.mysqld.new
+config etc/mysqlaccess.conf.new
+config etc/my.cnf.new
+config etc/my.cnf.d/client.cnf.new
+config etc/my.cnf.d/mysql-clients.cnf.new
+config etc/my.cnf.d/server.cnf.new
+config etc/logrotate.d/mysql.new
+

var/vabs/mariadb/src/mariadb.SlackBuild

+#!/usr/bin/bash
+# This script assumes it will be launched within "/NAME/VERSION/src" dir.
+# With all sources in "src" Your Vector Linux .txz package, slack-desc,
+# and slack-required will be found in "VERSION" dir. The extraction and
+# build will be in a temp dir created in "NAME" dir, and then removed on exit.
+# Comment out second to last line to keep this dir intact.
+#
+# This Template was compiled from the contributions of many users of the Vector
+# Linux forum at http://forum.vectorlinux.com and from tidbits collected 
+# from all over the internet. 
+#
+# Generated by sbbuilder-0.4.14.1, written by Rodrigo Bistolfi 
+# (rbistolfi) and Raimon Grau Cuscó (Kidd) for VectorLinux.
+#
+# Please put your name below if you add some original scripting lines.
+# AUTHORS = 
+
+NAME="mariadb"            #Enter package Name!
+VERSION=${VERSION:-"5.5.31"}      #Enter package Version!
+VER=$(echo $VERSION|sed 's/-/_/') #this fixes - in version
+VL_PACKAGER=${VL_PACKAGER:-"hata_ph"}   #Enter your Name!
+LINK=${LINK:-"http://mirrors.supportex.net/$NAME/$NAME-$VERSION/kvm-tarbake-jaunty-x86/$NAME-$VERSION.tar.gz"}  #Enter URL for package here!
+
+
+#SYSTEM VARIABLES
+#----------------------------------------------------------------------------
+BUILDNUM=${BUILDNUM:-"1"}
+VL_VERSION=${VL_VERSION:-"$(ls /var/log/packages/|grep vlconfig2|cut -d "-" -f4|cut -c 2-5)"}
+BUILD=${BUILD:-"$BUILDNUM""$VL_VERSION"}
+ARCH=${ARCH:-"$(uname -m)"}
+CONFIG_OPTIONS=${CONFIG_OPTIONS:-""}
+LDFLAG_OPTIONS=${LDFLAG_OPTIONS:-""}
+ADDRB=${ADDRB:-""} #Add deps that need to be added to the slack-required file here
+EXRB=${EXRB:-""} #Add deps that need to be excluded from the slack-required file here
+MAKEDEPENDS=${MAKEDEPENDS:-""} #Add deps needed TO BUILD this package here.
+#----------------------------------------------------------------------------
+
+# DO NOT EXECUTE if NORUN is set to 1
+if [ "$NORUN" != "1" ]; then
+
+#SETUP PACKAGING ENVIRONMENT
+#--------------------------------------------
+CWD=$(pwd)
+cd ../
+RELEASEDIR=$(pwd)
+cd $CWD
+mkdir -p $RELEASEDIR/tmp
+TMP=$RELEASEDIR/tmp
+PKG=$TMP/package-$NAME
+#--------------------------------------------
+
+# To reduce the package size, the embedded server my be omitted.  Currently
+# only amarok uses this.  To build without embedded support, set this to NO. 
+EMBEDDED=${EMBEDDED:-YES}
+
+# Add a description tag to the $BUILD.  This is used by
+# "build_embedded_package.sh" to mark packages containing the embedded server,
+# but can optionally be used with any kind of custom tag desired.
+TAG=${TAG:-}
+
+# Don't keep the large static libraries by default:
+KEEPSTATIC=${KEEPSTATIC:-NO}
+
+# Don't keep the test suite by default:
+KEEPTESTS=${KEEPTESTS:-NO}
+
+NUMJOBS=${NUMJOBS:-" -j7 "}
+
+if [ $UID != 0 ]; then
+   echo "You are not authorized to run this script. Please login as root"
+   exit 1
+fi
+
+if [ ! -x /usr/bin/requiredbuilder ]; then
+   echo "Requiredbuilder not installed, or not executable."
+   exit 1
+fi
+
+if [ $VL_PACKAGER = "YOURNAME" ]; then
+   echo 'Who are you?
+   Please edit VL_PACKAGER=${VL_PACKAGER:-YOURNAME} in this script.
+   Change the word "YOURNAME" to your VectorLinux packager name.
+   You may also export VL_PACKAGER, or call this script with
+   VL_PACKAGER="YOUR NAME HERE"'
+   exit 1
+fi
+
+
+#CFLAGS SETUP
+#--------------------------------------------
+if [[ "$ARCH" = i?86 ]]; then
+  ARCH=i586
+  SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+  CONFIGURE_TRIPLET="i586-vector-linux"
+  LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+  SLKCFLAGS="-O2 -fpic"
+  CONFIGURE_TRIPLET="x86_64-vector-linux"
+  LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "powerpc" ]; then
+  SLKCFLAGS="-O2"
+  CONFIGURE_TRIPLET="powerpc-vlocity-linux"
+  LIBDIRSUFFIX=""
+fi
+
+export CFLAGS="$SLKCFLAGS $CFLAG_OPTIONS"
+export CXXFLAGS=$CFLAGS
+export LDFLAGS="$LDFLAGS $LDFLAG_OPTIONS"
+#--------------------------------------------
+
+
+#GET THE SOURCE
+#--------------------------------------------
+for SRC in $(echo $LINK);do
+if [ ! -f $CWD/$(basename $SRC) ]
+then
+        wget --no-check-certificate -c $SRC
+fi
+done
+#--------------------------------------------
+
+
+rm -rf $PKG
+cd $TMP
+rm -rf $NAME-$VERSION
+
+
+#EXTRACT SOURCES
+#-----------------------------------------------------
+echo "Extracting source..."
+tar xvf $CWD/$NAME-$VERSION.tar.* || exit 1
+#this moves whatever was extracted to the std dirname we are expecting
+mv * $NAME-$VERSION &> /dev/null 2>&1
+mkdir -p $PKG
+#-----------------------------------------------------
+
+
+cd $TMP/$NAME-$VERSION
+
+
+#PATCHES
+#-----------------------------------------------------
+# Put any Patches here *NOTE this only works if all 
+# your patches use the -p1 strip option!
+#-----------------------------------------------------
+#for i in $CWD/patches/*;do
+#  patch -p1 <$i
+#  mkdir -p $PKG/usr/doc/$NAME-$VERSION/patches/
+#  cp $i $PKG/usr/doc/$NAME-$VERSION/patches/
+#done
+#-----------------------------------------------------
+ 
+ 
+
+#SET PERMISSIONS
+#-----------------------------------------
+echo "Setting permissions..."
+chown -R root:root .
+find . -perm 664 -exec chmod 644 {} \;
+find . -perm 777 -exec chmod 755 {} \;
+find . -perm 2777 -exec chmod 755 {} \;
+find . -perm 775 -exec chmod 755 {} \;
+find . -perm 2755 -exec chmod 755 {} \;
+find . -perm 774 -exec chmod 644 {} \;
+find . -perm 666 -exec chmod 644 {} \;
+find . -perm 600 -exec chmod 644 {} \;
+find . -perm 444 -exec chmod 644 {} \;
+find . -perm 400 -exec chmod 644 {} \;
+find . -perm 440 -exec chmod 644 {} \;
+find . -perm 511 -exec chmod 755 {} \;
+find . -perm 711 -exec chmod 755 {} \;
+find . -perm 555 -exec chmod 755 {} \;
+#-----------------------------------------
+
+
+
+#CONFIGURE & MAKE
+#----------------------------------------------------------------------
+# If you are building a KDE-related app, then change the following
+# arguments in the script below:
+# --prefix=$(kde-config -prefix) \
+# --sysconfdir=/etc/kde \
+#
+# Making these changes will ensure that your package will build in the
+# correct path and that it will work seamlessly within the KDE environment.
+#
+#-----------------------------------------------------------------------
+
+echo "Configuring source..."
+mkdir build
+cd build
+cmake \
+  -DCMAKE_C_FLAGS="$SLKCFLAGS" \
+  -DCMAKE_CXX_FLAGS="$SLKCFLAGS -felide-constructors -fno-exceptions -fno-rtti" \
+  -DBUILD_CONFIG=mysql_release \
+  -DFEATURE_SET="community" \
+  -DINSTALL_LAYOUT="RPM" \
+  -DCMAKE_INSTALL_PREFIX=/usr \
+  -DINSTALL_LIBDIR="lib${LIBDIRSUFFIX}" \
+  -DINSTALL_SBINDIR=libexec \
+  -DINSTALL_INCLUDEDIR=include/mysql \
+  -DINSTALL_MYSQLSHAREDIR=share/mysql \
+  -DINSTALL_SQLBENCHDIR= \
+  -DINSTALL_MYSQLTESTDIR=mysql-test \
+  -DINSTALL_MANDIR=man \
+  -DINSTALL_PLUGINDIR="lib${LIBDIRSUFFIX}/mysql/plugin" \
+  -DINSTALL_SCRIPTDIR=bin \
+  -DINSTALL_SUPPORTFILESDIR=share/mysql \
+  -DINSTALL_MYSQLDATADIR="/var/lib/mysql" \
+  -DINSTALL_DOCREADMEDIR="doc/${NAME}-$VERSION" \
+  -DINSTALL_DOCDIR="doc/${NAME}-$VERSION" \
+  -DMYSQL_DATADIR="/var/lib/mysql" \
+  -DMYSQL_UNIX_ADDR="/var/run/mysql/mysql.sock" \
+  -DWITH_EXTRA_CHARSETS=complex \
+  -DWITH_INNOBASE_STORAGE_ENGINE=1 \
+  -DENABLED_LOCAL_INFILE=ON \
+  -DWITH_EMBEDDED_SERVER=${EMBEDDED} \
+  -DWITH_READLINE=ON \
+  -DWITH_SSL=system \
+  -DWITH_ZLIB=system \
+  -DUSE_ARIA_FOR_TMP_TABLES=ON \
+  -DMANUFACTURER="Slackware" \
+  ..
+
+make $NUMJOBS || make || exit 1
+make install DESTDIR=$PKG || exit 1
+
+# Leave build directory:
+cd ..
+
+
+#######################################################################
+#Miscellenious tweaks and things outside a normal ./configure go here #
+#######################################################################
+
+
+if [ "$KEEPSTATIC" = "NO" ]; then
+  # Remove large static libraries:
+  rm -f $PKG/usr/lib${LIBDIRSUFFIX}/libmysqlclient.a
+  rm -f $PKG/usr/lib${LIBDIRSUFFIX}/libmysqlclient_r.a
+  rm -f $PKG/usr/lib${LIBDIRSUFFIX}/libmysqld.a
+fi
+
+if [ "$KEEPTESTS" = "NO" ]; then
+  # Do not include the test suite:
+  rm -rf $PKG/usr/mysql-test
+fi
+
+# The ./configure option to omit this has gone away, so we'll omit it
+# the old-fashioned way.  It's all in the source tarball if you need it.
+rm -rf $PKG/usr/sql-bench
+
+# This is the directory where databases are stored
+mkdir -p $PKG/var/lib/mysql
+chown mysql.mysql $PKG/var/lib/mysql
+chmod 0750 $PKG/var/lib/mysql
+
+# This is where the socket is stored
+mkdir -p $PKG/var/run/mysql
+chown mysql.mysql $PKG/var/run/mysql
+chmod 0755 $PKG/var/run/mysql
+
+# Add init script:
+mkdir -p $PKG/etc/rc.d
+# This is installed chmod 644 so that the server does not run by default.
+cp -a $CWD/rc.mysqld $PKG/etc/rc.d/rc.mysqld.new
+rm -rf $PKG/etc/init.d
+
+# Install mysqlaccess.conf
+install -m 644 scripts/mysqlaccess.conf $PKG/etc/mysqlaccess.conf.new
+
+# Mark config files under /etc as .new
+mv $PKG/etc/my.cnf $PKG/etc/my.cnf.new
+mv $PKG/etc/logrotate.d/mysql $PKG/etc/logrotate.d/mysql.new
+for i in client mysql-clients server; do
+  mv $PKG/etc/my.cnf.d/$i.cnf $PKG/etc/my.cnf.d/$i.cnf.new
+done
+
+mkdir -p $PKG/usr/doc/$NAME-$VERSION
+cp -a COPYING* INSTALL* KNOWN_BUGS* README VERSION \
+$PKG/usr/doc/$NAME-$VERSION
+cat $CWD/$NAME.SlackBuild > $PKG/usr/doc/$NAME-$VERSION/$NAME.SlackBuild
+
+#----------------------------------------------------------------------
+
+if [ -d $PKG/usr/share/man ];then
+mkdir -p $PKG/usr/man
+mv $PKG/usr/share/man/* $PKG/usr/man
+rm -rf $PKG/usr/share/man
+fi
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+
+if [ -d $PKG/usr/share/info ];then
+mkdir -p $PKG/usr/info
+mv $PKG/usr/share/info/* $PKG/usr/info
+rm -rf $PKG/usr/share/info
+fi 
+find $PKG/usr/info -type f -exec gzip -9 {} \;
+
+mkdir -p $PKG/install
+cp -a $CWD/doinst.sh $PKG/install/
+
+if [ -d $PKG/usr/info ];then
+cat >> $PKG/install/doinst.sh << EOF
+CWD=\$(pwd)
+cd usr/info
+if [ -f dir ];then
+    rm dir
+fi
+if [ -f dir.gz ];then
+    rm dir.gz
+fi
+for i in *.info.gz;do
+    install-info \$i dir
+done
+cd \$CWD
+EOF
+fi
+
+cat >> $PKG/install/doinst.sh << EOF
+# update rarian database
+if [ -x usr/bin/rarian-sk-update ]; then
+  usr/bin/rarian-sk-update 1> /dev/null 2> /dev/null
+fi
+
+# update mime database
+if [ -x usr/bin/update-mime-database ]; then
+  usr/bin/update-mime-database usr/share/mime 1> /dev/null 2> /dev/null
+fi
+
+# update desktop entries
+if [ -x usr/bin/update-desktop-database ]; then
+  usr/bin/update-desktop-database 1> /dev/null 2> /dev/null
+fi
+
+# update hicolor icons
+if [ -e usr/share/icons/hicolor/icon-theme.cache ]; then
+	rm -f usr/share/icons/hicolor/icon-theme.cache
+fi
+usr/bin/gtk-update-icon-cache -f -q usr/share/icons/hicolor 1>/dev/null 2>/dev/null
+
+if [ -x /usr/bin/glib-compile-schemas ]; then
+  /usr/bin/glib-compile-schemas usr/share/glib-2.0/schemas/ >/dev/null 2>&1
+fi
+
+# Restart gconfd-2 if running to reload new gconf settings
+if ps acx | grep -q gconfd-2 ; then
+        killall -HUP gconfd-2 ;
+fi
+
+# A good idea whenever kernel modules are added or changed:
+if [ -x sbin/depmod ]; then
+  /sbin/depmod -a 1> /dev/null 2> /dev/null
+fi
+EOF
+
+#if there is a slack-desc in src dir use it
+if test -f $CWD/slack-desc; then
+cp $CWD/slack-desc $RELEASEDIR/slack-desc
+else
+# This creates the white space in front of "handy-ruler" in slack-desc below.
+
+LENGTH=$(expr length "$NAME")
+SPACES=0
+SHIM=""
+until [ "$SPACES" = "$LENGTH" ]; do
+SHIM="$SHIM "
+let SPACES=$SPACES+1
+done
+
+# Fill in the package summary between the () below.
+# Then package the description, License, Author and Website.
+# There may be no more then 11 $NAME: lines in a valid slack-desc.
+
+cat > $RELEASEDIR/slack-desc << EOF
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.  Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in.  You must
+# make exactly 11 lines for the formatting to be correct.  It's also
+# customary to leave one space after the ':'.
+
+$SHIM|-----handy-ruler------------------------------------------------------|
+$NAME: $NAME (Drop-in replacement for the MySQL Database Server)
+$NAME:
+$NAME: MariaDB is a backward compatible, drop-in replacement branch of the
+$NAME: MySQL(R) Database Server.  It includes all major open source storage
+$NAME: engines, including the Aria storage engine.
+$NAME: 
+$NAME:
+$NAME:
+$NAME: License: GPL
+$NAME: Authors: http://mariadb.org/
+$NAME: Website: http://mariadb.org/
+
+EOF
+fi
+cat >> $RELEASEDIR/slack-desc << EOF
+
+
+
+#----------------------------------------
+BUILDDATE: $(date)
+PACKAGER:  $VL_PACKAGER
+HOST:      $(uname -srm)
+DISTRO:    $(cat /etc/vector-version)
+CFLAGS:    $CFLAGS
+LDFLAGS:   $LDFLAGS
+CONFIGURE: $(awk "/\\$\ \.\/configure\ /" $TMP/$DIRNAME/config.log)
+
+EOF
+
+cat $RELEASEDIR/slack-desc > $PKG/install/slack-desc
+
+#STRIPPING
+#------------------------------------------------------------------------------------------------------------------
+cd $PKG
+echo " "
+echo "Stripping...."
+echo " "
+find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+#------------------------------------------------------------------------------------------------------------------
+
+
+#FINISH PACKAGE
+#--------------------------------------------------------------
+echo "Finding dependencies..."
+ADD="$ADDRB" EXCLUDE="$EXRB" requiredbuilder -v -y -s $RELEASEDIR $PKG
+echo "Creating package $NAME-$VERSION-$ARCH-$BUILD.txz"
+makepkg -l y -c n $RELEASEDIR/$NAME-$VERSION-$ARCH-$BUILD.txz
+
+cd $CWD
+echo "Cleaning up temp files..." && rm -rf $TMP
+echo "Package Complete"
+fi
+#--------------------------------------------------------------
+
+# vim: set tabstop=4 shiftwidth=4 foldmethod=marker : ##

var/vabs/mariadb/src/rc.mysqld

+#!/bin/sh
+# Start/stop/restart mysqld.
+#
+# Copyright 2003  Patrick J. Volkerding, Concord, CA
+# Copyright 2003  Slackware Linux, Inc., Concord, CA
+# Copyright 2008, 2013  Patrick J. Volkerding, Sebeka, MN, USA
+#
+# This program comes with NO WARRANTY, to the extent permitted by law.
+# You may redistribute copies of this program under the terms of the
+# GNU General Public License.
+
+# To start MariaDB automatically at boot, be sure this script is executable:
+# chmod 755 /etc/rc.d/rc.mysqld
+
+# Before you can run MariaDB, you must have a database.  To install an initial
+# database, do this as root:
+#
+#   mysql_install_db --user=mysql
+#
+# Note that the mysql user must exist in /etc/passwd, and the created files
+# will be owned by this dedicated user.  This is important, or else mysql
+# (which runs as user "mysql") will not be able to write to the database
+# later (this can be fixed with 'chown -R mysql.mysql /var/lib/mysql').
+#
+# To increase system security, consider using "mysql_secure_installation"
+# as well.  For more information on this tool, please read:
+#   man mysql_secure_installation
+
+# To allow outside connections to the database comment out the next line.
+# If you don't need incoming network connections, then leave the line
+# uncommented to improve system security.
+SKIP="--skip-networking"
+
+# Uncomment the next line to use Oracle's InnoDB plugin instead of the included XtraDB
+#INNODB="--ignore-builtin-innodb --plugin-load=innodb=ha_innodb.so"
+
+# Start mysqld:
+mysqld_start() {
+  if [ -x /usr/bin/mysqld_safe ]; then
+    # If there is an old PID file (no mysqld running), clean it up:
+    if [ -r /var/run/mysql/mysql.pid ]; then
+      if ! ps axc | grep mysqld 1> /dev/null 2> /dev/null ; then
+        echo "Cleaning up old /var/run/mysql/mysql.pid."
+        rm -f /var/run/mysql/mysql.pid
+      fi
+    fi
+    /usr/bin/mysqld_safe --datadir=/var/lib/mysql --pid-file=/var/run/mysql/mysql.pid $SKIP $INNODB &
+  fi
+}
+
+# Stop mysqld:
+mysqld_stop() {
+  # If there is no PID file, ignore this request...
+  if [ -r /var/run/mysql/mysql.pid ]; then
+    killall mysqld
+    # Wait at least one minute for it to exit, as we don't know how big the DB is...
+    for second in 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 \
+      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 60 ; do
+      if [ ! -r /var/run/mysql/mysql.pid ]; then
+        break;
+      fi
+      sleep 1
+    done
+    if [ "$second" = "60" ]; then
+      echo "WARNING:  Gave up waiting for mysqld to exit!"
+      sleep 15
+    fi
+  fi
+}
+
+# Restart mysqld:
+mysqld_restart() {
+  mysqld_stop
+  mysqld_start
+}
+
+case "$1" in
+'start')
+  mysqld_start
+  ;;
+'stop')
+  mysqld_stop
+  ;;
+'restart')
+  mysqld_restart
+  ;;
+*)
+  echo "usage $0 start|stop|restart"
+esac